include \masm32\include\masm32rt.inc
.data?
pressedN	dd ?
.code
dhErrors	db "** DebugHeap found errors **", 0
GetDotExe:
  xor ecx, ecx
  .Repeat
	inc ecx
	mov eax, [edi+ecx]
	or eax, 20202000h
  .Until eax=="exe." || ecx>127
retn
WinMain proc
LOCAL sinfo:STARTUPINFO, pinfo:PROCESS_INFORMATION, debev:DEBUG_EVENT
Local dwContinueStatus, ctEx, ctErrs, buffer[4000]:BYTE
; 	pushad
; 	invoke MessageBox, 0, chr$("DEBUGHEAP"), chr$("Title"), MB_OK
; 	popad
  mov edi, esp
  xor eax, eax
  .Repeat
	stosd	; ClearLocals
  .Until edi>=ebp
  invoke GetCommandLine
  xchg eax, edi
  call GetDotExe
  .if Zero?
	mov ebx, edi
	lea edi, [edi+ecx+4]
	.Repeat
		inc edi
	.Until byte ptr [edi]>34	; get first arg
	call GetDotExe
	.if Zero?
		print "#DebH#", 13	; see [url=http://preshing.com/20110717/the-windows-heap-is-slow-when-launched-from-the-debugger/]RtlDebugAllocateHeap[/url]
			invoke Sleep, 100
			xor ecx, ecx
		invoke CreateProcess, ecx, edi, ecx, ecx, ecx, DEBUG_PROCESS or DEBUG_ONLY_THIS_PROCESS, ecx, ecx, addr sinfo, addr pinfo
		.if eax
			lea esi, debev
			DebEvent equ [esi.DEBUG_EVENT]
			.While 1
				mov dwContinueStatus, DBG_CONTINUE
				invoke WaitForDebugEvent, esi, 2000
					mov ecx, pinfo.dwProcessId
					.if ecx==DebEvent.dwProcessId	; consider only the current process (otherwise SHIMVIEW problem on Win 8.1)
						.Break .if DebEvent.dwDebugEventCode==EXIT_PROCESS_DEBUG_EVENT
						switch DebEvent.dwDebugEventCode
						; case EXIT_THREAD_DEBUG_EVENT
						; deb 4, "Exit Thread", pinfo.dwProcessId, pinfo.dwThreadId, pinfo.hProcess, pinfo.hThread, eax
						
						case EXCEPTION_DEBUG_EVENT
							.if pressedN || DebEvent.u.Exception.pExceptionRecord.ExceptionCode==6BAh		; FolderOpen$
								mov dwContinueStatus, DBG_EXCEPTION_NOT_HANDLED
							.else
								.if ctEx>4
									print "*"
									.if ctEx>9 && DebEvent.u.Exception.pExceptionRecord.ExceptionCode==EXCEPTION_ACCESS_VIOLATION
; 										mov ecx, DebEvent.u.Exception.pExceptionRecord.ExceptionInformation[4]
; 										print hex$(ecx), "=eip acc violation 1", 13, 10
										mov ecx, DebEvent.u.Exception.pExceptionRecord.ExceptionAddress
										print hex$(ecx), "=eip acc violation", 13, 10
									.endif
								.endif
								inc ctEx
								test byte ptr ctEx, 7
								.if Zero?
									MsgBox 0, "Exceptions: continue (y), ignore(n), or cancel?", offset dhErrors, MB_YESNOCANCEL or MB_TOPMOST or MB_SETFOREGROUND
									.Break .if eax==IDCANCEL
									.if eax==IDNO
										; print " n "
										inc pressedN
										mov dwContinueStatus, DBG_EXCEPTION_NOT_HANDLED
									.endif
								.endif
							.endif
					       case OUTPUT_DEBUG_STRING_EVENT
							invoke GetConsoleWindow
							.if !eax
								call AllocConsole
							.endif
							print chr$(13, 10, "## ")
							inc ctErrs
							lea edi, buffer
							if 0
								invoke lstrcpy, edi, chr$(13, 10, "debugevent")
							else
								invoke ReadProcessMemory, pinfo.hProcess,
									DebEvent.u.DebugString.lpDebugStringData,
									edi,
									DebEvent.u.DebugString.nDebugStringiLength, 0
								endif
							print edi			; the debugheap process is susy console!
					if 0
						default
							print "code "
							print str$(DebEvent.dwDebugEventCode), " "
					endif
						endsw
					.endif
					@@:
				invoke ContinueDebugEvent, DebEvent.dwProcessId, DebEvent.dwThreadId, dwContinueStatus
			.Endw
				; Close process and thread handles. 
				invoke CloseHandle, addr pinfo.hProcess
				invoke CloseHandle, addr pinfo.hThread
; 			.else	; never seen
; 				print "CreateProcess ["
; 				print edi, "]:", 13, 10
; 				print LastError$()
			.endif
		.else
			lea edi, buffer
			invoke MessageBox, 0, cat$(edi, "Bad command line: [", ebx, "]"), 0, MB_OK
; 			print "Bad command line: ["
; 			print ebx, "]"
		.endif
  .endif
  .if ctErrs
	print chr$(13, 10, offset dhErrors)
  .endif
  exit
WinMain endp
end WinMain
OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; for ultra short executables
OPT_Arg1	J:\Masm32\MasmBasic\Res\DebugHeapTestMasm32.exe
OxPT_Arg1	\Masm32\MasmBasic\Res\DebugHeapTest.exe
OPT_Susy	Console
OxPT_NoDebug	; doesn't work here because of Arg1
